BindCommand "Collapse_IndexedFaceSets",,"IFS tools|Collapse IndexedFaceSets"
BindPopup "Collapse_IndexedFaceSets","Collapse IndexedFaceSets","Transform,Transform.*"

sub Collapse_IndexedFaceSets
	set ent=CurrentEntity
	if ent is nothing then
		MsgBox "Please select a Transform",48
		Exit Sub
	end if
	if ent.EntityType=vpField then set ent=ent.Owner
	if ent.EntityType<>vpNode then
		MsgBox "Please select a Transform",48
		Exit Sub
	elseif ent.TypeName<>"Transform" then
		MsgBox "Please select a Transform",48
		Exit Sub
	end if

	BeginOperation "collapsing"
	l=sqr(ent("rotation").x^2+ent("rotation").y^2+ent("rotation").z^2)
	if l=0 then
		ent("rotation").Set 0,0,1,0
	else
		ent("rotation").x=ent("rotation").x/l
		ent("rotation").y=ent("rotation").y/l
		ent("rotation").z=ent("rotation").z/l
	end if
	set matrix=ent.Matrix
	num=0

	for i=1 to ent("children").count
		if ent("children")(i).TypeName="Shape" then
			if ent("children")(i)("geometry").Value.TypeName="IndexedFaceSet" then
				if not ent("children")(i)("geometry")("coord").Implicit then
					if ent("children")(i)("geometry")("coord").Value.EntityType=vpNode then
						matrix.ApplyTransform ent("children")(i)("geometry")("coord")("point")
						num=num+1
					end if
				end if
			end if
		end if
	next
	
	if num=0 then
		MsgBox "No IndexedFaceSets found",48
	else
		MsgBox num&" IndexedFaceSets processed",64
		ent.Matrix=NewMatrix
	end if

	EndOperation
end sub

BindCommand "Locate_in_MF_field",,"Locate in MF field"
BindPopup "Locate_in_MF_field","Locate in MF field","*.{MFColor},*.{MFFloat},*.{MFInt32},*.{MFNode},*.{MFRotation},*.{MFString},*.{MFTime},*.{MFVec2f},*.{MFVec3f}"

sub Locate_in_MF_field
	set ent=CurrentEntity
	if ent is nothing then
		MsgBox "Please select an MF field",48
		Exit Sub
	end if
	if ent.EntityType<5 or ent.EntityType>7 then
		MsgBox "Please select an MF field",48
		Exit Sub
	end if
	if ent.Type<12 then
		MsgBox "Please select an MF field",48
		Exit Sub
	end if
	set sel=Document.Selection
	str=""
	i=1
	j=ent.count
	do
		m=int((i+j)/2)
		set rng=ent.ValueRange(m)
		if(rng.FromLine<sel.FromLine or rng.FromLine=sel.FromLine and rng.FromRow<=sel.FromRow)and(rng.ToLine>sel.ToLine or rng.ToLine=sel.ToLine and rng.ToRow>=sel.ToRow)then
			str="."&vbCrLf&"The cursor is on the element "&m-1&vbCrLf
			exit do
		end if
		if rng.FromLine<sel.FromLine or rng.FromLine=sel.FromLine and rng.FromRow<sel.FromRow then
			i=m+1
		else
			j=m-1
		end if
	loop until i>j
	MsgBox "This field contains "&ent.count&" elements"&str,64
end sub

BindCommand "Find_item_in_MF_field",,"Find item in MF field"
BindPopup "Find_item_in_MF_field","Find item in MF field","*.{MFColor},*.{MFFloat},*.{MFInt32},*.{MFNode},*.{MFRotation},*.{MFString},*.{MFTime},*.{MFVec2f},*.{MFVec3f}"

sub Find_item_in_MF_field
	set ent=CurrentEntity
	if ent is nothing then
		MsgBox "Please select an MF field",48
		Exit Sub
	end if
	if ent.EntityType<5 or ent.EntityType>7 then
		MsgBox "Please select an MF field",48
		Exit Sub
	end if
	if ent.Type<12 then
		MsgBox "Please select an MF field",48
		Exit Sub
	end if

	n=ent.Count
	i=0+InputBox("This field contains "&n&" elements."&vbCrLf&"Which element do you want to find?")+0
	if i<0 or i>=n then
		MsgBox "Incorrect index!",16
	else
		ent.ValueRange(i+1).Select
	end if
end sub

BindCommand "Collapse_Transforms",,"IFS tools|Collapse Transforms"
BindPopup "Collapse_Transforms","Collapse Transforms","Transform,Transform.*"

sub Collapse_Transforms
	set ent=CurrentEntity
	if ent is nothing then MsgBox "Please select a Transform",16:Exit Sub
	if ent.EntityType=vpField then set ent=ent.Owner
	if ent.EntityType<>vpNode then MsgBox "Please select a Transform",16:Exit Sub
	if ent.TypeName<>"Transform" then MsgBox "Please select a Transform",16:Exit Sub
	if ent("children").Count=0 then MsgBox "Transform must contain Transforms",16:Exit Sub
	for i=1 to ent("children").Count
		set child=ent("children")(i)
		if child.TypeName<>"Transform" then MsgBox "Transform must contain"&vbCrLf&"only Transforms",16:Exit Sub
	next

	BeginOperation("collapsing")
	
	l=sqr(ent("rotation").x^2+ent("rotation").y^2+ent("rotation").z^2)
	if l=0 then
		ent("rotation")=Array(0,0,1,0)
	else
		ent("rotation").x=ent("rotation").x/l
		ent("rotation").y=ent("rotation").y/l
		ent("rotation").z=ent("rotation").z/l
	end if

	for i=1 to ent("children").Count
		set child=ent("children")(i)

		l=sqr(child("rotation").x^2+child("rotation").y^2+child("rotation").z^2)
		if l=0 then
			child("rotation")=Array(0,0,1,0)
		else
			child("rotation").x=child("rotation").x/l
			child("rotation").y=child("rotation").y/l
			child("rotation").z=child("rotation").z/l
		end if
	
		child.Matrix=ent.Matrix.multiply(child.Matrix)

		Window.StatusText cint(i/ent("children").Count*100)&"%"
	next

	set rng=ent.Range
	set rng2=ent("children")(1).Range.Begin
	rng2.FromLine=rng.FromLine
	rng2.FromRow=rng.FromRow
	set rng3=ent("children")(ent("children").Count).Range.End
	rng3.ToLine=rng.ToLine
	rng3.ToRow=rng.ToRow
	rng2.Delete
	rng3.Delete

	EndOperation
	Window.StatusText "Ok"
end sub

BindCommand "Merge_IndexedFaceSets",,"IFS tools|Merge IndexedFaceSets"
BindPopup "Merge_IndexedFaceSets","Merge IndexedFaceSets","Transform,Transform.*,Group,Group.*,*.{MFNode}"

sub Merge_IndexedFaceSets
	set ent=CurrentEntity
	if ent is nothing then
		MsgBox "Please select an MFNode field",48
		Exit Sub
	end if
	if ent.EntityType=vpNode then
		if ent.TypeName="Transform"or ent.TypeName="Group"then
			set ent=ent("children")
		else
			MsgBox "Please select an MFNode field",48
			Exit Sub
		end if
	elseif ent.EntityType=vpField then
		if ent.Type<>vpfMFNode then
			MsgBox "Please select an MFNode field",48
			Exit Sub
		end if
	else
		MsgBox "Please select an MFNode field",48
		Exit Sub
	end if

	BeginOperation "merge"
	num=0

	for i=1 to ent.count
		if ent(i).TypeName="Shape" then
			if ent(i)("geometry").Value.TypeName="IndexedFaceSet" then
				if not ent(i)("geometry")("coord").Implicit then
					if ent(i)("geometry")("coord").Value.EntityType=vpNode then
						if num=0 then
							set point=ent(i)("geometry")("coord")("point")
							set ind=ent(i)("geometry")("coordIndex")
							pointNum=point.Count
						else
							set point1=ent(i)("geometry")("coord")("point")
							set ind1=ent(i)("geometry")("coordIndex")
							for j=1 to point1.Count
								point.Add Array(point1(j).x,point1(j).y,point1(j).z)
							next
							if(ind(ind.Count)>=0) then ind.Add -1
							for j=1 to ind1.Count
								k=ind1(j)
								if k>=0 then k=k+pointNum
								ind.Add k
							next
							pointNum=pointNum+point1.Count
							ent(i)("geometry").Value.Delete
						end if
						num=num+1
					end if
				end if
			end if
		end if
	next
	
	if num=0 then
		MsgBox "No IndexedFaceSets found",48
	else
		MsgBox num&" IndexedFaceSets merged",64
	end if

	EndOperation
end sub

'BindCommand "Reverse_MFValue_field",,"Reverse MFValue field"
BindPopup "Reverse_MFValue_field","Reverse MFValue field","*.{MFVec3f},*.{MFVec2f},*.{MFRotation},*.{MFInt32},*.{MFFloat}"

sub Reverse_MFValue_field
	BeginOperation "reverse"

	set ent=CurrentEntity.Value

	count=ent.Count
	if CurrentEntity.Type=vpfMFVec3f then
		jMax=3
	elseif CurrentEntity.Type=vpfMFVec2f then
		jMax=2
	elseif CurrentEntity.Type=vpfMFRotation then
		jMax=4
	else
		jMax=1
	end if

	redim arr(count,jMax)
	for i=1 to count
		if jMax=1 then
			arr(i,1)=ent(i)
		else
			arr(i,1)=ent(i).x
			arr(i,2)=ent(i).y
			if jMax>2 then arr(i,3)=ent(i).z
			if jMax=4 then arr(i,4)=ent(i).angle
		end if
	next
	for i=1 to count
		if jMax=1 then
			ent(i)=arr(count+1-i,1)
		else
			ent(i).x=arr(count+1-i,1)
			ent(i).y=arr(count+1-i,2)
			if jMax>2 then ent(i).z=arr(count+1-i,3)
			if jMax=4 then ent(i).angle=arr(count+1-i,4)
		end if
	next

	EndOperation
end sub

BindCommand "Collapse_Transforms_in_the_whole_file",,"IFS tools|Collapse Transforms in the whole file"

sub Collapse_Transforms_in_the_whole_file

	BeginOperation("collapsing")
	
	np=0
	ne=0
	no=0
	
	for each ent in Document.StdProtos("Transform").Instances
		if ent("children").Count=0 then
			ne=ne+1
		else
			found=0
			for i=1 to ent("children").Count
				set child=ent("children")(i)
				if child.TypeName<>"Transform" then found=1
			next
			if found=1 then
				no=no+1
			else
	
				l=sqr(ent("rotation").x^2+ent("rotation").y^2+ent("rotation").z^2)
				if l=0 then
					ent("rotation")=Array(0,0,1,0)
				else
					ent("rotation").x=ent("rotation").x/l
					ent("rotation").y=ent("rotation").y/l
					ent("rotation").z=ent("rotation").z/l
				end if
			
				for i=1 to ent("children").Count
					set child=ent("children")(i)
			
					l=sqr(child("rotation").x^2+child("rotation").y^2+child("rotation").z^2)
					if l=0 then
						child("rotation")=Array(0,0,1,0)
					else
						child("rotation").x=child("rotation").x/l
						child("rotation").y=child("rotation").y/l
						child("rotation").z=child("rotation").z/l
					end if
				
					child.Matrix=ent.Matrix.multiply(child.Matrix)
				next
			
				set rng=ent.Range
				set rng2=ent("children")(1).Range.Begin
				rng2.FromLine=rng.FromLine
				rng2.FromRow=rng.FromRow
				set rng3=ent("children")(ent("children").Count).Range.End
				rng3.ToLine=rng.ToLine
				rng3.ToRow=rng.ToRow
				rng2.Delete
				rng3.Delete
				
				np=np+1
			end if
		end if
	next

	EndOperation
	
	MsgBox np&" Transforms processed"&vbCrLf&ne&" empty Transforms"&vbCrLf&no&" Transforms with wrong nodes inside"
end sub

BindCommand "Collapse_IndexedFaceSets_in_the_whole_file",,"IFS tools|Collapse IndexedFaceSets in the whole file"

sub Collapse_IndexedFaceSets_in_the_whole_file

	BeginOperation "collapsing"
	
	nt=0
	ns=0
	ne=0

	total=Document.StdProtos("Transform").Instances.Count
	counter=0
	
	for each ent in Document.StdProtos("Transform").Instances
		Window.StatusText cint(counter/total*100)&"%"
		counter=counter+1

		l=sqr(ent("rotation").x^2+ent("rotation").y^2+ent("rotation").z^2)
		if l=0 then
			ent("rotation").Set 0,0,1,0
		else
			ent("rotation").x=ent("rotation").x/l
			ent("rotation").y=ent("rotation").y/l
			ent("rotation").z=ent("rotation").z/l
		end if
		set matrix=ent.Matrix
		num=0
	
		for i=1 to ent("children").count
			if ent("children")(i).TypeName="Shape" then
				if ent("children")(i)("geometry").Value.TypeName="IndexedFaceSet" then
					if not ent("children")(i)("geometry")("coord").Implicit then
						if ent("children")(i)("geometry")("coord").Value.EntityType=vpNode then
							matrix.ApplyTransform ent("children")(i)("geometry")("coord")("point")
							num=num+1
						end if
					end if
				end if
			end if
		next
		
		if num=0 then
			ne=ne+1
		else
			ns=ns+num
			nt=nt+1
			ent.Matrix=NewMatrix
		end if
		
	next

	EndOperation

	Window.StatusText "Ok"
	MsgBox nt&" Transforms processed"&vbCrLf&ns&" Shapes processed"&vbCrLf&ne&" empty Transforms"
end sub

BindCommand "Triangulate",,"IFS tools|Triangulate faces randomly"
BindPopup "Triangulate","Triangulate faces randomly","IndexedFaceSet,IndexedFaceSet.*,Coordinate,Coordinate.*,Color,Color.*,Normal,Normal.*,TextureCoordinate,TextureCoordinate.*"

sub Triangulate
	randomize timer

	from=Document.Selection.FromLine
	set inst=Document.StdProtos("IndexedFaceSet").Instances
	found=0
	for i=1 to inst.Count
		if inst(i).Range.FromLine<=from and inst(i).Range.ToLine>=from then
			set ent=inst(i)
			found=1
			exit for
		end if
	next
	if found=0 then
		MsgBox "Please select an IndexedFaceSet",64
		Exit Sub
	end if
	
	BeginOperation "triangulate"

	set point=ent("coord")("point")
	set ind=ent("coordIndex")
	numInd=ind.Count
	redim newInd(numInd*4),face(100),face1(100)

	i=1
	k=0
	do
		j=i
		n=0
		do
			face(n)=ind(j)
			n=n+1
			j=j+1
			if j>numInd then exit do
		loop until ind(j)<0

		for f=0 to j-i-3
			r=int(rnd*n)
			for g=0 to 2
				newInd(k)=face((r+g)mod n)
				k=k+1
			next
			newInd(k)=-1
			k=k+1
			for g=2 to n
				face1(g-2)=face((r+g)mod n)
			next
			for g=0 to n-2
				face(g)=face1(g)
			next
			n=n-1
		next
		i=j+1
		
		progress i/numInd*.3
	loop until i>numInd
	
	ind.Clear
	for i=0 to k-1
		ind.add newInd(i)
		
		progress .3+i/k*.7
	next

	EndOperation
	Window.StatusText "Ok"
end sub

BindCommand "UnCCW",,"IFS tools|Convert all IndexedFaceSets to ccw TRUE"

sub UnCCW
	BeginOperation "Convert to ccw TRUE"
	n=Document.StdProtos("IndexedFaceSet").Instances.Count
	i=0
	counter=0
	for each ent in Document.StdProtos("IndexedFaceSet").Instances
		i=i+1
		Window.StatusText i&" of "&n&"..."
		if not ent("ccw").Value then
			counter=counter+1
			ent("ccw").Value=true
			ent("ccw").Implicit=true
			j=1
			do while j<=ent("coordIndex").Count
				k=j
				do while k<=ent("coordIndex").Count
					if ent("coordIndex")(k)=-1 then exit do
					k=k+1
				loop
				for m=int((k-j-1)/2) to 0 step -1
					t=ent("coordIndex")(j+m)
					ent("coordIndex")(j+m)=ent("coordIndex")(k-1-m)
					ent("coordIndex")(k-1-m)=t
				next
				j=k+1
			loop
		end if
	next
	Window.StatusText "Ok"
	EndOperation
	MsgBox "Converted "&counter&" shapes of "&n,64
end sub

BindPopup "round","Round numeric values","*.{MFFloat},*.{MFVec3f},*.{MFVec2f},*.{MFRotation}"

sub round
	BeginOperation "rounding"

	set ent=CurrentEntity.Value

	count=ent.Count
	if CurrentEntity.Type=vpfMFVec3f then
		jMax=3
	elseif CurrentEntity.Type=vpfMFVec2f then
		jMax=2
	else
		jMax=4
	end if

	mult=0
	for i=1 to count
		if CurrentEntity.Type<>vpfMFFloat then
			for j=1 to jMax
				if j=1 then a=ent(i).x
				if j=2 then a=ent(i).y
				if j=3 then a=ent(i).z
				if j=4 then a=ent(i).angle
				s=a&""
				if instr(s,"E")=0 then
					b=instr(s,",")
					if b>0 then
						c=len(s)-b
						if mult<c then mult=c
					end if
				end if
			next
		else
			a=ent(i)
			s=a&""
			if instr(s,"E")=0 then
				b=instr(s,",")
				if b>0 then
					c=len(s)-b
					if mult<c then mult=c
				end if
			end if
		end if
		progress i/count/5
	next
	
	mult=InputBox("The precision is "&mult&" fractional digits."&vbCrLf&"To which precision do you want to round?",,mult)
	if mult="" then exit sub

	mult=10^mult
	for i=1 to count
		if CurrentEntity.Type<>vpfMFFloat then
			ent(i).x=((ent(i).x*mult)or 0)/mult
			ent(i).y=((ent(i).y*mult)or 0)/mult
			if jmax>2 then ent(i).z=((ent(i).z*mult)or 0)/mult
			if jmax>3 then ent(i).angle=((ent(i).angle*mult)or 0)/mult
		else
			ent(i)=((ent(i)*mult)or 0)/mult
		end if
		progress .2+i/count*.8
	next
	Window.StatusText "Ok"
end sub

oldProgress=-1

private sub progress(a)
	if a>1 then a=.9
	p=cint(a*100)
	if p=oldProgress then exit sub
	oldProgress=p
	Window.StatusText "-------------------------------- "&p&"% --------------------------------"
end sub